package javaio;

import java.nio.file.Files;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

public class JavaFileStreamIO {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		List<Cat> cats = getCatsFromFileStream("data/cats.txt");
		System.out.println("-----------Java File IO with Stream--------  ---");
		for (Cat cat : cats) {
			System.out.println(cat);
		}
	}

	// Java Stream 编程实现
	static List<Cat> getCatsFromFileStream(String fileName) {
		List<Cat> cats = new ArrayList<>();
		try {
			cats = Files.lines(Path.of(fileName))	// 获取每一行组成的stream
					.filter(line -> line.trim().length() > 0 // 筛选非空行
					&& !line.startsWith("#") // 且不以#开头
					&& line.split(",").length == 3) // 且合法（是3个属性）
					.map(line -> { // 将一行转换成一个Cat object
						String[] properties = line.split(",\\s*");
						Cat cat = new Cat();
						cat.name = properties[0];
						cat.breed = properties[1];
						cat.age = Integer.parseInt(properties[2].trim());
						return cat;
					}).collect(Collectors.toList()); // 收集每一行生成的Ojbect，输出一个List
		} catch (Exception e) {
			e.printStackTrace();
		}
		return cats;

	}
}
